﻿module hdk.sdlbase;
version (hdk_lib) private import sdl;

uint getTicks() { return SDL_GetTicks(); } /// ミリセカンド単位
void sleep(uint ms) { SDL_Delay(ms); } ///

template SdlBase()
{
	private import hdk.error;
	private import std.utf;
	private import std.openrj;
	private import std.file;
	private import std.conv;
	mixin SdlError;
	
	private const char[] INIT_RJ = "init.rj";
	
	private static bit initialized = false;
	uint width() { return SDL_GetVideoSurface().w; }
	uint height() { return SDL_GetVideoSurface().h; }
	void swapBuffers() { SDL_GL_SwapBuffers(); }
	
	this()
	{
		if (initialized) error(__LINE__);
		initialized = true;
		
		Database data = new Database(cast(char[])read(INIT_RJ), 0);
		uint initWidth = toUint(data[0]["width"]);
		uint initHeight = toUint(data[0]["height"]);
		
		SDL_Init(SDL_INIT_VIDEO);
		SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 8);
		SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 8);
		SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 8);
		SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_SetVideoMode(initWidth, initHeight, 24, SDL_OPENGL);
		
		SDL_WM_SetCaption(toStringz(data[0]["caption"]), null);
	}
	
	~this()
	{
		SDL_Quit();
		initialized = false;
	}
	
	bit doEvents()
	{
		SDL_Event event;
		while (SDL_PollEvent(&event))
		{
			if (event.type == SDL_QUIT) return false;
		}
		return true;
	}
}
