﻿import std.cstream;
import std.file;
import nanami.toutf8fromsjis;
import nanami.mqo;
import nanami.mkm;
import nanami.skeleton;

// mikotoからmkmをエクスポートするとQuaternion.nameの一部が欠損するときがある
int main()
{
	try
	{
		dout.writeLine("skeleton test begin...");
		
		const char[] MQO_FILE_NAME = `..\resource\test.mqo`;
		
		//const char[] MKM_FILE_NAME = `..\resource\test0.mkm`;
		//const char[] MKM_FILE_NAME = `..\resource\test1.mkm`;
		const char[] MKM_FILE_NAME = `..\resource\test2.mkm`;
		
		char[] mqoSrc = toUtf8FromSjis(cast(char[])read(MQO_FILE_NAME));
		char[] mkmSrc = toUtf8FromSjis(cast(char[])read(MKM_FILE_NAME));
		Mqo mqo = new Mqo(new MemoryStream(mqoSrc));
		Skeleton skeleton = new Skeleton(mqo);
		Mkm mkm = new Mkm(new MemoryStream(mkmSrc));
		assert(mkm.motion[0].quaternion.length == skeleton.boneList.length);
		int error = 0;
		for (int i = 0; i < skeleton.boneList.length; i++)
		{
			if (mkm.motion[0].quaternion[i].name != skeleton.boneList[i].name)
			{
				dout.writeLine(mkm.motion[0].quaternion[i].name);
				dout.writeLine(skeleton.boneList[i].name);
				error++;
			}
			assert(mkm.motion[0].quaternion[i].name == skeleton.boneList[i].name);
		}
		dout.writefln("error count=%d ", error);
		
		dout.writeLine("skeleton test end");
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}
