﻿import coneneko.all;

mixin Main!(Test);

auto class Test : Window
{
	override void main()
	{
		const dchar[] BG_FILE0 = `test0.png`;
		const dchar[] BG_FILE1 = `test1.png`;
		const dchar[] MODEL_FILE = `test.773`;
		
		text = "テスト開始";
		waitInput();
		
		text = "背景の選択";
		const dchar[][] bgList = [ BG_FILE0, BG_FILE1, null ];
		backImage = bgList[waitChoice(`"test0.png"`, `"test1.png"`, "null")];
		
		text = "モデルの設定、左";
		createModel("test", MODEL_FILE);
		model["test"].position = Vector(-60, 0, 0);
		model["test"].motion = 0;
		waitInput();
		
		text = "中央";
		model["test"].position = Vector(0, 0, 0);
		model["test"].motion = 1;
		waitInput();
		
		text = "右";
		model["test"].position = Vector(60, 0, 0);
		model["test"].motion = 2;
		waitInput();
		
		text = "跳ぶ";
		with (model["test"])
		{
			position = Vector(0, 0, 0);
			motion = 3;
			nextMotion = 4;
		}
		waitInput();
		
		text = "playEffect";
		model["test"].motion = 0;
		playEffect("effect.png", 4, Rectangle(0, 0, 0.5, 0.5));
		waitInput();
		
		text = "visibleItem";
		model["test"].visibleItem(0, true);
		waitInput();
		
		model["test"].visibleItem(0, false);
		text = "playMorph";
		model["test"].playMorphing(0, 0.4, 0.5);
		waitInput();
		
		text = "stopMorph";
		model["test"].stopMorphing(0);
		waitInput();
		
		deleteModel("test");
		
		text = "テスト終了";
		waitInput();
	}
}


/+
import coneneko;
import std.cstream;

int main()
{
	dout.writeLine("process start");
	dout.flush();
	
	MyDLL_Initialize(std.gc.getGCHandle());
	foo(getMyClass());
	MyDLL_Terminate();
	
	dout.writeLine("process end");
	dout.flush();
	return 0;
}

void foo(MyClass c)
{
	char[] s;
	s = c.concat("Hello", "world!");
	dout.writeLine(s);
	dout.flush();
	c.free(s);
	delete c;
}
+/
